<?php

namespace Flipbox\Relay\HubSpot\Segment\ContactLists;

use Flipbox\Relay\HubSpot\Middleware\Client;
use Flipbox\Relay\HubSpot\Middleware\ContactLists\Remove as ContactListRemoveMiddleware;
use Flipbox\Relay\Middleware\Stash as CacheMiddleware;
use Flipbox\Relay\Segments\AbstractSegment;
use Psr\Cache\CacheItemPoolInterface;
use Flipbox\Relay\HubSpot\Middleware\JsonRequest as JsonRequestMiddleware;

class Remove extends AbstractSegment
{
    /**
     * @var int
     */
    public $id;

    /**
     * @var array
     */
    public $vids = [];

    /**
     * @var array
     */
    public $emails = [];

    /**
     * @return array
     */
    protected function defaultSegments(): array
    {
        return [
            'body' => [
                'class' => JsonRequestMiddleware::class,
                'payload' => $this->assemblePayload(),
                'logger' => $this->getLogger()
            ],
            'uri' => [
                'class' => ContactListRemoveMiddleware::class,
                'id' => $this->id,
                'logger' => $this->getLogger()
            ],
            'client' => [
                'class' => Client::class,
                'logger' => $this->getLogger()
            ]
        ];
    }

    /**
     * @return array
     */
    protected function assemblePayload(): array
    {
        return [
            'vids' => array_filter($this->vids),
            'emails' => array_filter($this->emails)
        ];
    }
}
